function [alpha,beta,gammak]=convolTerms(niter,E,dt)
% Antoine-Besse April 2004
% Computation of the convolution terms
% Taylor expansion of sqrt(1-X)
sgn=-1;
Z(1)=1;
Z(2)=0.5*sgn;
for j=1:niter
    Z(j+2)=Z(j+1)*(0.5-j)*sgn/(j+1);
end;
%Taylor expansion of 1/sqrt(1+X)
sgn=1;
N(1)=1;
N(2)=-0.5*sgn;
for j=1:niter
    N(j+2)=N(j+1)*(-0.5-j)*sgn/(j+1);
end;
co=conv(Z,N);
alpha=co(1:niter)';
beta=alpha;
for j=2:2:niter,
    beta(j)=-beta(j);
end
gammak=zeros(niter+2,1);
kk=(1:(niter)/2+2)';
co=(2*kk-1)./(2*kk);
gammak(1)=1;
for j=1:niter/2+1
    gammak(2*j+1)=co(j)*gammak(2*(j-1)+1);
end
