function [Mat] = getSysMatFEM(p,e,b,ML,MR,s0)
% echo : flag turning output in shell on or off
% print : flag turning several plots on or off

k = 0;
d = 0;
ne = size(e,2);
np = size(p,2);
ndof = np;

% Equations Physical domain
MMPD = sparse(ndof,ndof); % Massmatrix
KKPD = sparse(ndof,ndof);
%DDPD = sparse(ndof,ndof);
for kk = 1:ne
  MMPD(e(:,kk),e(:,kk)) = MMPD(e(:,kk),e(:,kk)) + ...
      (p(e(2,kk))-p(e(1,kk)))*[1/3 1/6;
		    1/6 1/3]; 
  KKPD(e(:,kk),e(:,kk)) = KKPD(e(:,kk),e(:,kk)) + (1/(p(e(2,kk))-p(e(1,kk))))*...
      [-1 1;
       1 -1]; 
 % DDPD(e(:,kk),e(:,kk)) = DDPD(e(:,kk),e(:,kk)) + ...
 %     [-1/2 1/2;
 %      -1/2 1/2]; 
end
Mat.MMPD = MMPD;
%full(MMPD)
%full(KKPD)
%full(DDPD)
KKPD = KKPD - k^2*MMPD; % Laplace - k^2
%DDPD = 2*d*DDPD; % Drift
%KKPD = KKPD+DDPD;
MMPD = MMPD(2:end-1,:);
KKPD = KKPD(2:end-1,:);

P_PD   = sparse(ML+[1:ndof],[1:ndof],ones(1,ndof),ndof+ML+MR,ndof);
P_PDI  = sparse(ML+[2:ndof-1],[1:ndof-2],ones(1,ndof-2),ndof+ML+MR,ndof-2);
MMPDT = P_PDI*MMPD*P_PD'; 
KKPDT = P_PDI*KKPD*P_PD';

h = p(2)-p(1);
% Coupling equation s^0
MMC = sparse([ 1, h/3, h/6 , 0, 0, 0;
	       0, 0 ,0, h/6, h/3, 1]);

KKC = sparse([ -(k^2+d^2), -(k^2*h/3+1/h), -(k^2*h/6-1/h-d), 0, 0, 0; ...
	       0, 0, 0,-(k^2*h/6-1/h+d) , -(k^2*h/3+1/h) ,  -(k^2+d^2)]);
N1C =  sparse([0, 1, 0, 0, 0, 0; ...
	       0, 0, 0, 0, 1, 0]);
N2C =  sparse([1, 0, 0, 0, 0, 0; ...
	       0, 0, 0, 0, 0, 1]);

KSC =  KKC + s0^2*N2C + s0*N1C;

P_C =  sparse([ML ML+1 ML+2 ML+ndof-1 ML+ndof ML+ndof+1],...
		      [1 : 6],ones(1,6),ndof+ML+MR,6);
P_CI = sparse([ML+1,ML+ndof],[1 2],ones(1,2),ndof+ML+MR,2);

MMCT = P_CI*MMC*P_C';
KKCT = P_CI*KKC*P_C';
KSCT = P_CI*KSC*P_C';
N1CT = P_CI*N1C*P_C';
N2CT = P_CI*N2C*P_C';

% a0 Equation s^1
% 
MMA0 = sparse([1, 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, 1]);
KKA0 = sparse([(-k^2-d^2), 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, (-k^2-d^2)]);
N1A0 = sparse([ 0, 0, 2, 0, 0, 0;
		0, 0, 0, 2, 0,  0]);
N2A0 = sparse([1 , 4, 0, 0, 0, 0;
	       0, 0, 0, 0, 4, 1]);

KSA0 =  KKA0 + s0^2*N2A0 + s0*N1A0;

P_A0 =  sparse([ML-1 ML ML+1 ML+ndof ML+ndof+1 ML+ndof+2],...
		      [1 : 6],ones(1,6),ndof+ML+MR,6);
P_A0I = sparse([ML,ML+ndof+1],[1 2],ones(1,2),ndof+ML+MR,2);

MMA0T = P_A0I*MMA0*P_A0';
KKA0T = P_A0I*KKA0*P_A0';
KSA0T = P_A0I*KSA0*P_A0';
N1A0T = P_A0I*N1A0*P_A0';
N2A0T = P_A0I*N2A0*P_A0';

% a1 Equation s^2
% 
MMA1 = sparse([1, -1, 0, 0, 0, 0;
	       0, 0, 0, 0, -1, 1]);
KKA1 = sparse([(-k^2-d^2), (+k^2+d^2) , 0, 0, 0,          0;
	       0,          0,           0, 0, (+k^2+d^2), (-k^2-d^2)]);
N1A1 = sparse([0, 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, 0]);
N2A1 = sparse([1, 3, 4, 0, 0, 0;
	       0, 0, 0, 4, 3, 1]);
KSA1 =  KKA1 + s0^2*N2A1 + s0*N1A1;

P_A1 =  sparse([ML-2 ML-1 ML ML+ndof+1 ML+ndof+2 ML+ndof+3],...
		      [1 : 6],ones(1,6),ndof+ML+MR,6);
P_A1I = sparse([ML-1,ML+ndof+2],[1 2],ones(1,2),ndof+ML+MR,2);

MMA1T = P_A1I*MMA1*P_A1';
KSA1T = P_A1I*KSA1*P_A1';
KKA1T = P_A1I*KKA1*P_A1';
N1A1T = P_A1I*N1A1*P_A1';
N2A1T = P_A1I*N2A1*P_A1';

% aj Equations
% p*ajm1 -2*p*aj + p*ajp1 =  (s0^2-k^2-2*d*s0)*ajp1 +2*(s0^2+k^2)*aj +  (s0^2-k^2+2*d*s0)*ajm1
eL = ones(ML-1,1);
xAJL = spdiags([eL -2*eL eL],-1:1,ML-1,ML-1);
yAJL = spdiags([eL  2*eL eL],-1:1,ML-1,ML-1);
zAJL = spdiags([-eL 0*eL eL],-1:1,ML-1,ML-1);

MMAJL = xAJL;
KKAJL = -(k^2+d^2)*xAJL;
N1AJL = 0*zAJL;
N2AJL = yAJL;
KSAJL = KKAJL + s0^2*N2AJL + s0*N1AJL;

MMAJL = MMAJL(1:end-1,:);
KSAJL = KSAJL(1:end-1,:);
KKAJL = KKAJL(1:end-1,:);
N1AJL = N1AJL(1:end-1,:);
N2AJL = N2AJL(1:end-1,:);

P_AJL = sparse([1:ML-1],[1:ML-1],ones(1,ML-1),ndof+ML+MR,ML-1);
P_AJLI = sparse([1:ML-2],[1:ML-2],ones(1,ML-2),ndof+ML+MR,ML-2);
MMAJLT = P_AJLI*MMAJL*P_AJL';
KSAJLT = P_AJLI*KSAJL*P_AJL';
KKAJLT = P_AJLI*KKAJL*P_AJL';
N1AJLT = P_AJLI*N1AJL*P_AJL';
N2AJLT = P_AJLI*N2AJL*P_AJL';

eR = ones(MR-1,1);
xAJR = spdiags([eR -2*eR eR],-1:1,MR-1,MR-1);
yAJR = spdiags([eR  2*eR eR],-1:1,MR-1,MR-1);
zAJR = spdiags([eR  0*eR -eR],-1:1,MR-1,MR-1);
MMAJR = xAJR;
KKAJR = -(k^2+d^2)*xAJR;
N1AJR = 0*zAJR;
N2AJR = yAJR;
KSAJR = KKAJR + s0^2*N2AJR + s0*N1AJR;

MMAJR = MMAJR(2:end,:);
KSAJR = KSAJR(2:end,:);
KKAJR = KKAJR(2:end,:);
N1AJR = N1AJR(2:end,:);
N2AJR = N2AJR(2:end,:);

P_AJR =  sparse([ndof+ML+2:ndof+ML+MR],[1:MR-1],ones(1,MR-1),ndof+ML+MR,MR-1);
P_AJRI = sparse([ndof+ML+3:ndof+ML+MR],[1:MR-2],ones(1,MR-2),ndof+ML+MR,MR-2);
MMAJRT = P_AJRI*MMAJR*P_AJR';
KSAJRT = P_AJRI*KSAJR*P_AJR';
KKAJRT = P_AJRI*KKAJR*P_AJR';
N1AJRT = P_AJRI*N1AJR*P_AJR';
N2AJRT = P_AJRI*N2AJR*P_AJR';

Mat.MM = MMPDT+MMCT+MMA0T+MMA1T+MMAJLT+MMAJRT;
Mat.KS = KKPDT+KSCT+KSA0T+KSA1T+KSAJLT+KSAJRT;
Mat.KK = KKPDT+KKCT+KKA0T+KKA1T+KKAJLT+KKAJRT;
Mat.N1 = N1CT+N1A0T+N1A1T+N1AJLT+N1AJRT;
Mat.N2 = N2CT+N2A0T+N2A1T+N2AJLT+N2AJRT;
Mat.P_PD = P_PD;