function [ph]=makeErrorPlots(ErrM,CpuM,TocM,data,NVec,dtVec,methods,fn,type)

% [stat,hostname] = system('echo $HOSTNAME');
% hostname = regexp(hostname,'\w*(?=\.)','match');
figure(fn); clf
subplot(2,2,1);
ph = line(squeeze(ErrM(:,end,:)).',squeeze(CpuM(:,end,:)).'); setMark
set(gca,'XScale','log')
set(gca,'YScale','log')
title(sprintf('Nx %g , dt: %g .. %g',NVec(end),dtVec(1),dtVec(end)))
xlabel('error'); ylabel('cputime')
subplot(2,2,2);
ph = line(squeeze(ErrM(:,:,end)).',squeeze(CpuM(:,:,end)).'); setMark
set(gca,'XScale','log')
set(gca,'YScale','log')
title(sprintf('Nx %g .. %g , dt: %g',NVec(1),NVec(end),dtVec(end)))
xlabel('error'); ylabel('cputime')
subplot(2,2,3); 
ph = loglog(dtVec,squeeze(ErrM(:,end,:)).'); setMark
title(sprintf('Nx %g , dt: %g .. %g',NVec(end),dtVec(1),dtVec(end)))
ylabel('error'); xlabel('dt')
subplot(2,2,4); 
ph = loglog((data.x1-data.x0)./NVec,squeeze(ErrM(:,:,end)).'); setMark
title(sprintf('Nx %g .. %g , dt: %g',NVec(1),NVec(end),dtVec(end)))
ylabel('error'); xlabel('dx')
xlim([0.8*(data.x1-data.x0)/NVec(end) 20*(data.x1-data.x0)/NVec(1)])
legend(methods)
orient landscape
eval(sprintf('print -dpdf error_%s',type))
eval(sprintf('print -depsc error_%s',type))


