function [A]=massMatrix(N,dx)
% Antoine-Besse April 2004
% Assembling of the finite element mass matrix.
% Linear Finite Elements
% N : size
% dx : mesh size

% Elementary matrix
El1 = (dx/6)*[ 2 , 1; ...,
        1 , 2];
e = zeros(N+2,1);

A = spdiags([e,e,e],[-1:1],N+2,N+2);

for j=1:N+1,
    A(j:j+1,j:j+1) = A(j:j+1,j:j+1)+El1;
end