function [A]=massMatrix3(N,dx)
% Antoine-Besse April 2004
% Assembling of the finite element mass matrix.
% Cubic Finite Elements
% N : size
% dx : mesh size

% Elementary matrix
El1=(dx/1680)*[128,99,-36,19; ...,
             99,648,-81,-36 ; ...,
             -36,-81,648,99; ...,
            19,-36,99,128]; 
e=zeros(N+2,1);

A=spdiags([e,e,e,e,e,e,e],[-3:3],N+2,N+2);
for j=1:3:N,
    A(j:j+3,j:j+3)=A(j:j+3,j:j+3)+El1;
end
