function [B]=stiffnessMatrix2(N,dx)
% Antoine-Besse April 2004
% Assembling of the finite element stiffness matrix.
% Quadratic Finite Elements
% N : size
% dx : mesh size

% Elementary matrix
El1=(1/dx/3)*[7, -8 ,1 ; ...,
              -8, 16, -8; ...,
              1, -8, 7];
e=zeros(N+2,1);

B=spdiags([e,e,e,e,e],[-2:2],N+2,N+2);
for j=1:2:N,
    B(j:j+2,j:j+2)=B(j:j+2,j:j+2)+El1;
end
