function [B]=stiffnessMatrix3(N,dx)
% Antoine-Besse April 2004
% Assembling of the finite element stiffness matrix.
% Cubic Finite Elements
% N : size
% dx : mesh size

% Elementary matrix
El1=(1/dx/40)*[148,-189,54,-13 ; ...,
              -189,432,-297,54; ...,
              54,-297,432,-189; ...,
              -13,54,-189,148];
e=zeros(N+2,1);

B=spdiags([e,e,e,e,e,e,e],[-3:3],N+2,N+2);
for j=1:3:N,
    B(j:j+3,j:j+3)=B(j:j+3,j:j+3)+El1;
end
